/*
*
*/
#ifndef driverC350_h
#define driverC350_h
//#include "WProgram.h"

#if defined(ARDUINO) && ARDUINO >= 100
  #include "Arduino.h"
#else
  #include "WProgram.h"
#endif 

//#include "Arduino.h"
#include "Spi.h"

//порт к которому подключен экран
//#define LcdPort PORTD
//#define LcdDdr  DDRD

//выводы arduino
#define DataCmd    8
#define Reset      9
#define LedDriver  7

//макроопределения
//#define byte unsigned char
//#define SBR(port, bit)        port |= (1<<bit)
//#define CBR(port, bit)        port &= (~(1<<bit))
//#define INV(port, bit)        port ^= (1<<bit)
//#define SBRC(port, bit)      ((port & (1<<bit)) == 0)
//#define SBRS(port, bit)      ((port & (1<<bit)) != 0)

#define ComSetColumnAddress     0x15  //установить адрес столбца
#define ComSetPageAddress       0x75  //установить адрес страницы
#define ComWriteDisplayData     0x5c  //записать данные на экран
#define ComSetLookUpTable       0xce  //установить таблицу перекодировки
#define ComSetNormalDisplay     0xa6  //нормальный дисплей
#define ComSetInverseDisplay    0xa7  //инверсия цветов
#define ComOnDisplay            0xaf  //включить экран
#define ComOffDisplay           0xae  //выключить экран
#define ComEnterSleepMode       0x95  //перейти в режим sleep
#define ComExitSleepMode        0x94  //выйти из режима leep
#define ComEnableIntOsc         0xd1  //разрешить внутренний генератор
#define ComDisableIntOsc        0xd2  //запретить внутренний генератор
#define ComIncContrast          0xd6  //инкременировать контраст
#define ComDecContrast          0xd7  //декременировать контраст
#define ComSetContrastIntReg    0x81  //установить контраст
#define ComDrawLine             0x83  //нарисовать линию
#define ComFillEnableDisable    0x92  //разрешить/запретить заполнение
#define ComDrawRectangle        0x84  //нарисовать прямоугольник
#define ComCopy                 0x8a  //копировать часть экрана
#define ComClearWindow          0x8e  //очистить часть экрана
#define ComSetDataOutputScanDir 0xbc  //установка параметров. смотри описание
#define ComSetPowerControlReg   0x20  
#define ComSetDisplayControl    0xca
#define ComSelectPwmFrc         0xf7
#define ComSetBiasingRatio      0xfb
#define ComSetComOutputScanDir  0xbb
#define ComDimWindow            0x8c
#define ComSetAreaScroll        0xaa
#define ComSetScrollStart       0xab 
#define ComDisplayOn            B10101111
#define ComDisplayOff           B10101110

//макрофункции
//#define InitLcd() Init()
//#define OnDisplay() SendCom(ComOnDisplay)
//#define OffDisplay() SendCom(ComOffDisplay)
//#define EnterSleepMode() SendCom(ComEnterSleepMode)
//#define ExitSleepMode() SendCom(ComExitSleepMode)
//#define IncContrast() SendCom(ComIncContrast)
//#define DecContrast() SendCom(ComDecContrast)
//#define SetNormalDisplay() SendCom(ComSetNormalDisplay) 
//#define SetInverseDisplay() SendCom(ComSetInverseDisplay)


class drvC350
{
  byte ColorPixel;
  byte ColorFill;
  SPI spi;
  public:
  drvC350(void);
// // команды инициализации
  void Init(void);
  void SendCom(byte data);
  void SendData(byte data);  

  void DisableIntOsc(void);
  void EnableIntOsc();
  void ExitSleepMode();
  void OnDisplay();
  void LedDriverOn();
  
//  //функции
  void SetDataOutputScanDir(byte adrscan, byte rgbcol, byte grayscale);
  void DrawLine(byte x1, byte y1, byte x2, byte y2, byte redgreen, byte blue);
  void DrawRectangle(byte x1, byte y1, byte x2, byte y2, byte redgreen1, byte blue1, byte redgreen2, byte blue2);
  void ClearDisplay(byte x1, byte y1, byte x2, byte y2);
  void SetContrastIntReg(byte contrast, byte regulator);
  void SetLookUpTable(void);
  void SetupDisplay(void);
  void FillDisable(void);
  void FillEnable(void);
  
  void SetAreaScroll(byte TopBlockAddress, byte BottomBlockAddress, byte NumberBlocksm, byte ScrollMode);  
  void SetScrollStart(byte StartBlockAddress);
  void DisplayOnOff(byte OnOff);

  //функции для знакогенератора
  void SetColor(byte cp, byte cf);
  void SendLcdSymbol(byte data, byte ColAdr, byte PageAdr);
  void SendLcdString(char* String, byte ColAdr, byte PageAdr);
  
  //дополнительные графические функции
  void PutPixel(byte ColAdr, byte PageAdr);
  void DrawCircle(byte xc,byte yc,byte r,byte color);
};

#endif
